/**
 * Created by Shrujan on 4/2/2015.
 */
(function() {
	app.controller('reportsCtrl', [
			"$scope",
			"approveTimeOffService",
			"adminServices",
			"validateObjectService",
			"Utils",
			"employeeServices",
			"timeOffDateDiffService",
			'reportsService',
			"$location",
			"i8nConstants",
			function($scope, approveTimeOffService, adminServices, validateObjectService, Utils, employeeServices,
					timeOffDateDiffService, reportsService, $location, i8nConstants) {
				if ($scope.levelFlag != "Manager" && $scope.levelFlag != "Admin") {
					$location.path("/applyleave");
				}
				$scope.halfDay = -1;
				$scope.loggedInUser = employeeServices.getProdcertName()
				$scope.teamMembers = employeeServices.getTeamMembers();
				$scope.leaveTypes = employeeServices.getLeaveTypes();
				timeOffDateDiffService.setTimeOffStartDate(undefined);
				timeOffDateDiffService.setTimeOffEndDate(undefined)
				$scope.regionList = [];
				$scope.report = [];
				$scope.loadingFlag = true;
				var selectedTeamMember = '';
				var selectedRegion = '';
				var leaveType = '';
				var startDate = '';
				var endDate = '';
				var pageNo = 1;
				$scope.startDate = '';
				$scope.endDate = '';
				$("#enddate").on("keydown", function(e) {
					return Utils.keepDateFieldReadable(e);
				});
				$("#startdate").on("keydown", function(e) {
					return Utils.keepDateFieldReadable(e);
				});
				$('.dropdown-toggle').off().on("click", function() {
					$(this).dropdown();
					$(this).parent().find(".dropdown-menu").toggleClass("show");
				});
				$(document).mouseup(function(e) {
					$(".dropdown-div .dropdown").find(".show").each(function() {
						$(this).toggleClass("show");
					});
				});
				adminServices.getListingObjArray("Location").then(function(response) {
					var locationLists = response;
					for (var i = 0; i < locationLists.length; i++) {
						$scope.regionList[i] = locationLists[i];
					}
				});
				refreshList();
				function refreshList() {
					reportsService.retrieveReports(pageNo,
							10,
							startDate,
							endDate,
							selectedTeamMember,
							selectedRegion,
							leaveType).then(function(response) {
						if (response != undefined) {
							$scope.report = response.MyTimeOffApprovals;
							$scope.reportCount = response.TotalTimeOffCount;
						} else {
							$scope.report = [];
							$scope.reportCount = 0;
						}
						$scope.loadingFlag = false;
					}, function() {
						$scope.report = [];
						$scope.reportCount = 0;
						$scope.loadingFlag = false;
					})
				}

				$scope.selectTeam = function(teamName, e) {
					selectedTeamMember = teamName;
					if (teamName == "") {
						$("#EmpSearchName .selVal").html(i8nConstants.SELECT_AN_EMPLOYEE_NAME)
					} else {
						$("#EmpSearchName .selVal").html(teamName)
					}
					$(e.target).parent().parent().parent().parent().find(".dropdown-toggle").trigger("click");
					$(".dropdown-div .dropdown").find(".show").each(function() {
						$(this).toggleClass("show");
					});
					//$(e).toggleClass("show");
				}
				$scope.selectTimeOffType = function(timeoffId, timeoffType, e) {
					if (timeoffType == "") {
						$("#SearchTimeOffType .selVal").html(i8nConstants.SELECT_TIME_OFF_TYPE);
						leaveType = '';
					} else {
						leaveType = timeoffId;
						$("#SearchTimeOffType .selVal").html(timeoffType)
					}
					$(e.target).parent().parent().parent().parent().find(".dropdown-toggle").trigger("click");
					$(".dropdown-div .dropdown").find(".show").each(function() {
						$(this).toggleClass("show");
					});
				}
				$scope.selectRegion = function(regionId, regionName, e) {
					if (regionName == "") {
						$("#searchLocation .selVal").html(i8nConstants.SELECT_LOCATION);
						selectedRegion = '';
					} else {
						selectedRegion = regionId;
						$("#searchLocation .selVal").html(regionName)
					}
					$(e.target).parent().parent().parent().parent().find(".dropdown-toggle").trigger("click");
					$(".dropdown-div .dropdown").find(".show").each(function() {
						$(this).toggleClass("show");
					});
				}
				$scope.pageChanged = function(pageno) {
					pageNo = pageno;
					refreshList();
				}
				$scope.filterNow = function() {
					pageNo = 1;
					startDate = (timeOffDateDiffService.getTimeOffStartDate() == undefined) ? ""
							: ((timeOffDateDiffService.getTimeOffStartDate().getMonth() + 1 < 10) ? "0" : "") +
									(timeOffDateDiffService.getTimeOffStartDate().getMonth() + 1) + "/" +
									((timeOffDateDiffService.getTimeOffStartDate().getDate() < 10) ? "0" : "") +
									timeOffDateDiffService.getTimeOffStartDate().getDate() + "/" +
									timeOffDateDiffService.getTimeOffStartDate().getFullYear();
					endDate = (timeOffDateDiffService.getTimeOffEndDate() == undefined) ? "" : ((timeOffDateDiffService
							.getTimeOffEndDate().getMonth() + 1 < 10) ? "0" : "") +
							(timeOffDateDiffService.getTimeOffEndDate().getMonth() + 1) +
							"/" +
							((timeOffDateDiffService.getTimeOffEndDate().getDate() < 10) ? "0" : "") +
							timeOffDateDiffService.getTimeOffEndDate().getDate() +
							"/" +
							timeOffDateDiffService.getTimeOffEndDate().getFullYear();
					if (endDate != "" && endDate != null)
						$scope.endDate = Utils.convertDateString(timeOffDateDiffService.getTimeOffEndDate());
					else
						$scope.endDate = '';
					if (startDate != "" && startDate != null)
						$scope.startDate = Utils.convertDateString(timeOffDateDiffService.getTimeOffStartDate());
					else
						$scope.startDate = '';
					refreshList();
				}
				$scope.convertDate = function(dateStr) {
					if (dateStr != undefined)
						return Utils.convertDateString(dateStr)
					else
						return "N.A"
				}
			} ])/*
				 * .controller('datePickerCtrl', ["$scope", "timeOffDateDiffService", "employeeServices",
				 * "$timeout", "Utils", "$location", function ($scope, timeOffDateDiffService,
				 * employeeServices, $timeout, Utils, $location) { // $scope.halfDay = 0; $scope.clear =
				 * function () { $scope.dt = null; }; if (($location.path() == "/applyleave") ||
				 * ($location.path() == "/reports")) { $scope.startdate = undefined; $scope.enddate =
				 * undefined; timeOffDateDiffService.setTimeOffStartDate($scope.startdate);
				 * timeOffDateDiffService.setTimeOffEndDate($scope.enddate); } $(document).ready(function () {
				 * $scope.setDate = function () { if ($scope.startdate == null) {
				 * $(".day-option").first().val("0"); $(".day-option:not(:first)").first().val("0"); }
				 * 
				 * if($(".day-option").first().val()=="0"){ $("#enddate").val(undefined);
				 * $("#dExpiryDate").val(undefined); }
				 * 
				 * timeOffDateDiffService.setTimeOffStartDate($scope.startdate);
				 * 
				 * if (timeOffDateDiffService.getTimeOffStartDate() == undefined) { $(".blue-popover").hide(); }
				 * else { console.log($scope.startdate); if($scope.enddate == undefined){
				 * timeOffDateDiffService.setTimeOffEndDate($scope.startdate); }
				 * 
				 * 
				 *  // $("#enddate").val(Utils.defaultDateFormat($scope.startdate));
				 * 
				 * //$("#enddate").trigger("change"); if
				 * (($(".datepicker").first().find(".day-option").first().val() != 0 ) &&
				 * ($(".datepicker").first().find(".day-option").first().val() != undefined)) {
				 * $("#enddate").val(Utils.defaultDateFormat($scope.startdate));
				 * timeOffDateDiffService.setTimeOffEndDate(new Date($("#enddate").val().replace(/-/g, "/")));
				 * $(".datepicker:not(:first)").first().find(".day-option").first().val($(".datepicker").first().find(".day-option").first().val());
				 * 
				 * $scope.$evalAsync(function(){ $scope.daysOfAbsence = 1; $scope.halfDayFlag = true;
				 * //$scope.halfDaySection =
				 * $(".datepicker").first().find(".day-option").first().find('option:selected').text(); });
				 * $(".blue-popover").show(); } else if (timeOffDateDiffService.getTimeOffEndDate() != null ||
				 * $scope.enddate != null || $scope.enddate == undefined) { $(".blue-popover").hide();
				 * $("#enddate").val(undefined); $(".blue-popover").hide();
				 * //$("#enddate").val(Utils.defaultDateFormat($scope.startdate));
				 * 
				 * timeOffDateDiffService.setTimeOffEndDate(new Date($("#enddate").val().replace(/-/g, "/")));
				 * $(".datepicker:not(:first)").first().find(".day-option").first().val($(".datepicker").first().find(".day-option").first().val());
				 * $scope.daysOfAbsence = 1; $scope.halfDayFlag = false; $scope.halfDaySection =
				 * $(".datepicker").first().find(".day-option").first().val(); $(".blue-popover").show(); } } }
				 * $scope.setDate(); }); $scope.disabled = function (date, mode) { return
				 * employeeServices.getDisabledHolidays(date, mode); } $scope.calDate = function () {
				 * employeeServices.setOptionalLeavesArray([]);
				 * timeOffDateDiffService.setTimeOffEndDate($scope.enddate); if
				 * (timeOffDateDiffService.getTimeOffEndDate() == undefined) { $(".blue-popover").hide(); }
				 * else { if (timeOffDateDiffService.getTimeOffStartDate() != null) { if
				 * (typeof(timeOffDateDiffService.getTimeOffStartDate()) == "string") {
				 * timeOffDateDiffService.setTimeOffStartDate(new
				 * Date(timeOffDateDiffService.getTimeOffStartDate().replace(/-/g, "/") + " 00:00:00")); } if
				 * (timeOffDateDiffService.getTimeOffStartDate().getTime() !=
				 * timeOffDateDiffService.getTimeOffEndDate().getTime()) { if($(".day-option").first().val() ==
				 * "0"){ // $scope.halfDayFlag = false; $(".day-option").first().val("0");
				 * $(".day-option:not(:first)").first().val("0"); } } $('.blue-popover').show();
				 * $(".optional-leave-div").show(); $(".error_enddate").hide(); $scope.optionalDivShowFlag =
				 * true; $scope.daysOfAbsence = timeOffDateDiffService.calculateDays();
				 * timeOffDateDiffService.setDaysOfAbsence($scope.daysOfAbsence); $scope.optionalLeaveDetails =
				 * timeOffDateDiffService.getOptionalLeaveDetails(); } } } var optionalLeaveTakenArray = [];
				 * $scope.consumeLeave = function (element, optionalLeave) { $scope.daysOfAbsence =
				 * $scope.daysOfAbsence - 1; timeOffDateDiffService.setDaysOfAbsence($scope.daysOfAbsence);
				 * if(optionalLeaveTakenArray.indexOf(Utils.respDateFormat(optionalLeave, true)) == -1){
				 * 
				 * optionalLeaveTakenArray.push(Utils.respDateFormat(optionalLeave, true)); }
				 * employeeServices.setOptionalLeavesArray(optionalLeaveTakenArray);
				 * //$scope.optionalDivShowFlag = false; $(element.target).parent().parent().hide(); }
				 * $scope.doNotConsumeLeave = function (element) { //$scope.daysOfAbsense =
				 * $scope.daysOfAbsense - $scope.optionalLeaveDetails.length; // $scope.optionalDivShowFlag =
				 * false; $(element.target).parent().parent().hide(); } // Disable weekend selection
				 * $scope.toggleMin = function () { }; $scope.toggleMin(); $scope.dateOptions = { showWeeks:
				 * 'false', dateFormat: 'dd-MMM-YYYY' };
				 * 
				 * $scope.select = function (val) { } $scope.openStartDate = function ($event) {
				 * $(document).on("click", ".btn-danger", function () { }); if ($scope.halfDay == -1) {
				 * $(".day-option").hide(); } if (($scope.halfDay !== "0") && ( $(".day-option").first().val() ==
				 * "0")) { $(".day-option").first().val($scope.halfDay.toString());
				 * $(".day-option:not(:first)").first().val($scope.halfDay.toString()); } $scope.showWeeks =
				 * false; // $event.preventDefault(); $event.stopPropagation(); $scope.opened = true; };
				 * $scope.openEndDate = function ($event) {
				 *  // $scope.enddate = Utils.defaultDateFormat(timeOffDateDiffService.getTimeOffEndDate()); //
				 * $("#enddate").val(Utils.defaultDateFormat($scope.enddate)) // $scope.enddate = undefined;
				 * employeeServices.setOptionalLeavesArray([]); if ($scope.halfDay == -1) {
				 * $(".day-option").hide(); } $scope.showWeeks = false; $scope.minDate =
				 * (timeOffDateDiffService.getTimeOffStartDate() == undefined) ? undefined : new
				 * Date(timeOffDateDiffService.getTimeOffStartDate());
				 * 
				 * //$scope.enddate = (timeOffDateDiffService.getTimeOffStartDate() == undefined) ? undefined :
				 * (typeof(timeOffDateDiffService.getTimeOffStartDate())== "string")? new
				 * Date(timeOffDateDiffService.getTimeOffStartDate().replace(/-/g,"/")):new
				 * Date(timeOffDateDiffService.getTimeOffStartDate());
				 * 
				 * 
				 * $scope.dateOptions = { formatYear: 'yy', startingDay: 1 }; if ($scope.halfDay !== "0") {
				 * $(".day-option").first().val($scope.halfDay.toString());
				 * $(".day-option:not(:first)").first().val($scope.halfDay.toString()); } if
				 * ($scope.halfDayFlag == true) { $scope.opened = false; //$scope.halfDaySection =
				 * $(".datepicker").first().find(".day-option").first().find('option:selected').text(); } else {
				 * $scope.opened = true; $scope.dateOptions.showButtonBar = true;
				 * $scope.dateOptions.dateDisabled = false; }
				 * 
				 * if(timeOffDateDiffService.getTimeOffEndDate() != undefined) $scope.enddate = new
				 * Date(timeOffDateDiffService.getTimeOffEndDate());
				 * 
				 * if(($("#dExpiryDate").length > 0 ) && ($("#dExpiryDate").val()!="")){ $scope.enddate = new
				 * Date($("#dExpiryDate").val().replace(/-/g,"/")); } if(($(".enddateclass").length > 0 ) &&
				 * ($("#enddate").val()!="")){ $scope.enddate = new
				 * Date($("#enddate").val().replace(/-/g,"/")); } $scope.calDate();
				 * 
				 * 
				 * 
				 * 
				 * $event.stopPropagation(); }; $scope.format = 'dd-MMMM-yyyy';
				 * }]).directive('datepickerPopup', function (){ return { restrict: 'EAC', require: 'ngModel',
				 * link: function(scope, element, attr, controller) { //remove the default formatter from the
				 * input directive to prevent conflict controller.$formatters.shift(); } } })
				 */;
})();